comment }
    CCLOCK.ASM:
      Read CMOS clock.  This trivial program came about because many games,
      among them Welltris, stop the DOS clock while they're running.  All
      we wanted was a simple program to reread the CMOS, and transfer the
      time into DOS.

    Usage:    CCLOCK
    No parameters, no message, nothing.

}

adjust  macro   arg1
        mov     al,arg1         ; get arg in AL
        call    d_to_b          ; adjust it to binary
        mov     arg1,al         ; put it back
        endm

CGROUP  GROUP   cseg
cseg    segment para public 'CODE'
        org     100h
        assume  cs:CGROUP, ds:CGROUP, es:CGROUP
main    proc    near
start:
        mov     dx,offset CGROUP:howdy          ; display greeting
        mov     ah,9
        int     21h
        mov     ah,02
        int     1ah
        jc      nogood
     ;  now if CMOS clock is running,
     ;     CH= hour,  CL= minutes               all BCD
     ;     DH= seconds
     ;    (DL= daylight savings code  00h = std,  01 = daylight)

        adjust  ch
        adjust  cl
        adjust  dh

        xor     dl,dl           ; hundredths = 00
        mov     ah,2dh          ; set time
        int     21h


        mov     dx,offset CGROUP:goodmsg        ; display normal message
        mov     ah,9
        int     21h
        mov     ax,4c00h        ; normal termination
        int     21h

nogood:
        mov     dx,offset CGROUP:errormsg
        mov     ah,9
        int     21h
        mov     ax,4c01h        ; error termination  (code = 01)
        int     21h

howdy           db      'CCLOCK 1.0  Free software by Dave Angel',13,10,'$'
goodmsg         db      'CMOS clock --> DOS clock',13,10,'$'
errormsg        db      'CMOS clock not working',13,10,'$'

main    endp

; given BCD value in AL (00 to 99), convert it to binary (00h to 63h)
;    mod regs AH,AL
d_to_b  proc    near
        mov     ah,al
        and     al,00fh
        and     ah,0f0h
        shr     ah,1
        shr     ah,1
        shr     ah,1
        shr     ah,1
        aad
        ret
d_to_b  endp


cseg    ends
        end     start
